! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile, CNRS.
! All rights reserved.
!
! DP code
! Linear Response TDDFT code in Frequency-Reciprocal space on a Plane Waves basis set.
! Calculate Dielectric Properties.

!     ==================================================================
!     20-nov-1997 subroutines for cpu clocking
!     ==================================================================


!     ==================================================================
      subroutine pclock(itimpt)
!     ==================================================================
!     print the timing point number
!     itimpt: timing point number
!     if itimpt = 0 start the clock
!     else print the cpu time elapsed since clock started
!     ------------------------------------------------------------------

      integer itimpt
!      integer, save :: stime
!      real cpu_time
      real, save :: cputime
      real, save :: realtime
      integer, save :: orcount
      integer, save :: occount
      integer rcount, rrate, rmax
      integer ccount, crate, cmax
      character cdate*8, ctime*10, czone*5
      integer datetimezone(8)
!     real, external :: second  ! Cray
!     real, external :: secnds  ! Vax
!     integer, external :: mclock  ! Aix
      
      if (itimpt.eq.0) then
!       start clock
        call date_and_time(cdate,ctime,czone,datetimezone)
        write(*,20) datetimezone(1:3), datetimezone(5:7)
20      format(' clock started    ',
     &         i4,'-',i2,'-',i2,'   ',i2,':',i2,':',i2)
!        stime = float(mclock())/100
        call cpu_clock(ccount,crate,cmax)
        call system_clock(rcount,rrate,rmax)
        occount = ccount
        orcount = rcount
        cpu_time = 0.0
        cputime = 0.0
        realtime = 0.0
      else
!        cpu_time = float(mclock())/100 - stime
        call cpu_clock(ccount,crate,cmax)
        call system_clock(rcount,rrate,rmax)
        if(ccount-occount >= 0) then
          cputime = cputime + float((ccount-occount))/crate
        else
          cputime = cputime + float((ccount-occount+cmax))/crate
        endif
        occount = ccount
        if(rcount-orcount >= 0) then
          realtime = realtime + float((rcount-orcount))/rrate
        else
          realtime = realtime + float((rcount-orcount+rmax))/rrate
        endif
        orcount = rcount
      endif

      write(6,50) itimpt, cputime, realtime
50    format (' timing point number ',i4/
     &        ' cpu time  = ',f10.2,' seconds'/
     &        ' real time = ',f10.2,' seconds'/)
     
      
      return
      end
