/*
Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile, CNRS.
All rights reserved.

DP code
Linear Response TDDFT code in Frequency-Reciprocal space on a Plane Waves basis set.
Calculate Dielectric Properties.
*/

/* 
dp.c: the shell to interface toward UNIX and call the real fortran main dpf.f
*/

#include <stdio.h>
#include <string.h>

main(argc,argv)
int argc;
char *argv[];
{
  int il, kl, gl, el, vl; /* filenames lengths */
  char *inputfile=NULL;   /* input filename */
  char *kssfile=NULL;     /* kss filename, qplda electronic structure */
  char *gwfile=NULL;      /* gw filename */
  char *em1file=NULL;     /* epsilon^-1 or screening filename */
  char *vkbfile=NULL;     /* obsolete */
  char *program;          /* program name */

  program = argv[0];

  read_command_line(argc,argv,&inputfile,&kssfile,&gwfile,&em1file,&vkbfile);

  il = check_file(&inputfile,"dp.in",program);
  kl = check_file(&kssfile,"in.kss",program);
  gl = check_file(&gwfile,"in.gw",program);
  vl = check_file(&vkbfile,"in.vkb",program);

  /* printf("files %s %s %s %s\n",inputfile,kssfile,gwfile,vkbfile); */

  /* call the fortran main */
  dp_(inputfile,&il,kssfile,&kl,gwfile,&gl,vkbfile,&vl);
}
