! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile, CNRS.
! All rights reserved.
!
! DP code
! Linear Response TDDFT code in Frequency-Reciprocal space on a Plane Waves basis set.
! Calculate Dielectric Properties.

c======================================================================
      subroutine printv(a,n)
c======================================================================
c     print parts of a complex vector
c----------------------------------------------------------------------

      complex a(n)
 
      write(6,100) (i,a(i), i=1,15)
100   format(i3,2f9.4)

      write(*,*)
      return
      end


c======================================================================
      subroutine printmr(a,n1,n1a,n2,n3,n)
c======================================================================
c----------------------------------------------------------------------

      complex a(n,n)

      do ix = 0, n1
      do iy = 0, n2
      do iz = 0, n3
        ir = 1 + ix + iy*n1a + iz*n1a*n2
        do jx = 0, n1
        do jy = 0, n2
        do jz = 0, n3
          jr = 1 + jx + jy*n1a + jz*n1a*n2
          
      write(6,200) ix,iy,iz,jx,jy,jz,a(ir,jr)
200   format(' (',3i3,',',3i3,') ',2f9.4)
        enddo
        enddo
        enddo
      enddo
      enddo
      enddo
      return
      end


!     ==================================================================
      subroutine printcm(a,n,m)
!     ==================================================================
!     print a complex matrix
!     ------------------------------------------------------------------
      complex a(n,m)

      write(*,50) (j, j=1,9)
50    format(5x,9(i2,6x))
      do i = 1, 9
        write(*,100) i, (real(a(i,j)), j=1,9)
100     format(i1,1x,9f8.3)
        write(*,110) (aimag(a(i,j)), j=1,9)
110     format(2x,9f8.3)
        print *
      enddo
      print *
      return
      end
