/*
Copyright (C) 1998-2007 Valerio Olevano, Francesco Sottile, CNRS.
All rights reserved.

DPutil
Spectroscopy Utilities
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLINELEN 500
char a[MAXLINELEN];

#define MAXCOMLINES 50
#define MAXCOMLEN 180
char comments[MAXCOMLINES][MAXCOMLEN];
int skip;

char *addext(char *filename, char *newext)
{
  int n;
  char *pc;
  n = strlen(filename) + strlen(newext) + 1;
  pc = calloc(n+1,sizeof(char));
  strcat(pc,filename);
  strcat(pc,".");
  strcat(pc,newext);
  return(pc);
}

char *changeext(char *filename, char *newext)
{
  int n;
  char *pc;
  n = strlen(filename) + strlen(newext) + 1;
  pc = calloc(n+1,sizeof(char));
  stripext(pc,filename);
  strcat(pc,".");
  strcat(pc,newext);
  return(pc);
}

stripext(char *dest, char *src)
{
  char *pc;
  int n;
  if((pc=strchr(src,'.'))!=NULL) {
    n = (int) (pc - src);
    strncpy(dest,src,n);
  } else {
    strcpy(dest,src);
  }
  return(1);
}

writefile(filename,n,nz,x,z)
char *filename;
int n, nz;
float x[n];
/* float z[n][nz]; */
float *z;
{
  FILE *fp;
  int i, j;
  fp = fopen(filename,"w");

  
  for(i=0;i<skip;i++) fprintf(fp,"%s",comments[i]);
  

  for(i=0;i<n;i++) {
    fprintf(fp,"%7.3f  ",x[i]);
    for(j=0;j<nz;j++)
/*      fprintf(fp,"%10.4e  ",z[i][j]); */
      fprintf(fp,"%10.4e  ",*z++); 
    fprintf(fp,"\n");
  }

  fclose(fp);
}
  



readfile(filename,pn,pny,px,py)
char *filename;
int *pn, *pny;
float **px, **py;  
{
  FILE *fp;
  int i, j;
  float *x, *y;
  int lines, col;
  int n, ny;

  testfile(filename,&lines,&col);
  n = lines;
  ny = col-1;
  *pn = n;
  *pny = ny;

  x = calloc(n,sizeof(float));
  y = calloc(n*ny,sizeof(float));

  fp = fopen(filename,"r");

  for(i=0;i<skip;i++) {
    fgets(&comments[i][0],MAXCOMLEN,fp);
    /* printf("%s",comments[i]); */
  }
  

  for(i=0;i<n;i++) {
    fscanf(fp,"%f",&x[i]);
    for(j=0;j<ny;j++) fscanf(fp,"%f",&y[i*ny+j]);
  }
  fclose(fp);
  *px = x;
  *py = y;
}
  

testfile(char *filename, int *plines, int *pcol)
{
  int lines=0, col=0;
  int n;
  char c;
  FILE *fp;
  fp = fopen(filename,"r");

  *plines=0;
  *pcol=0;
  skip = -1;
  do {
    skip++;
    if(fgets(a,MAXLINELEN,fp)==NULL) {fclose(fp); return(2);}
    /* printf("%s",a); */
  } while(a[0]=='#');

  /* printf("lines to skip %d\n",skip); */


  *pcol = colcount(a);

  /* printf("columns %d\n",*pcol); */

  lines = 1;
  while((c=getc(fp)) != EOF) if(c == '\n') lines++;
  *plines = lines;
  /* printf("lines %d\n",*plines); */
  
  fclose(fp);

  return(1);

}

colcount(char *a)
{
  int col=0;
  int i=0,n;
  char *pc;

  if((pc=strchr(a,'\n'))==NULL) return(0);
  n = (int) (pc - a);
  while(a[i]==' ' || a[i]=='\t') i++;
  while(i<n)
  {
    while(a[i]!=' ' && a[i]!='\t' && i<n) i++;
    col++;
    while(i<n && (a[i]==' ' || a[i]=='\t')) i++;
  }
  return(col);
}

readdsff(float *pdsf) 
{
  int i;
  *pdsf = 0.0;
  for(i=0;i<skip;i++) {
    if(strstr(comments[i],"dsf factor")!=NULL) {
      sscanf(comments[i],"# dsf factor %f",pdsf);
    }
  }
  return(1);
}

modifyfirstcomment(char *string) {strcpy(comments[0],string);}
modifylastcomment(char *string) {strcpy(comments[skip-1],string);}
addcomment(char *string)
{
  strcpy(comments[skip],string);
  skip++;
}
